import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.image.*;
import java.util.HashMap;
import java.io.*;
import java.net.URI;
import java.net.URISyntaxException;

//import chrriis.dj.nativeswing.NativeComponentWrapper;
//import com.frostwire.gui.webbrowser.*;

class ImageShow extends Canvas implements ImageObserver{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	//static final String imagesPath = "/Users/robert_leroy/pictures/Vienna 1";
	static final String imagesPath = "/home/pi/Pictures";

	Image img;
	Dimension ds;
	HashMap<Integer, String> imgFiles;
	String filename;
	int curImgIndex;

	ImageShow(){
		ds=getToolkit().getScreenSize();
		filename=null;
		setBackground(Color.BLACK);
	}

	public void paint(Graphics g){
		if(filename!=null){
			img=getToolkit().getImage(filename);                  
			drawIt(g,img);           
		}
	}

	public void drawIt(Graphics g, Image img){
		Graphics2D g2d=(Graphics2D)g;
		new javax.swing.ImageIcon(img); // force image to load
		
		int w=(int)ds.getWidth();
		int h=(int)ds.getHeight();      
		double a=ds.getHeight() / img.getHeight(this);
		
		w = (int) (img.getWidth(this) * a);
		h = (int) (img.getHeight(this) * a);
		
		int x=(int)(ds.getWidth()/2 - w/2);
		
		g2d.drawImage(img, x, 0, w, h, this);
	}

	public void storeImages(){
		
	
		imgFiles=new HashMap<Integer, String>();                  
	/*
		JFileChooser chooser = new JFileChooser();
		FileNameExtensionFilter filter = new FileNameExtensionFilter("Image Files", "jpg", "gif","png","gif","bmp");
		chooser.setFileFilter(filter);
		chooser.setMultiSelectionEnabled(true);
		int returnVal = chooser.showOpenDialog(this);
		if(returnVal == JFileChooser.APPROVE_OPTION) {
			File[] Files=chooser.getSelectedFiles();
			for( int i=0;i<Files.length;i++){     
				imgFiles.put(i,Files[i].toString());
			}
		}
	*/

		File[] files = new File(imagesPath).listFiles();
		
		//If this pathname does not denote a directory, then listFiles() returns null. 
		int countFiles = 0;
		for (File file : files) {
		    if (file.isFile()) {
//		    	String imageFullPath = imagesPath.concat("/");
//  	    	imageFullPath = imageFullPath.concat(file.getName());
//				imgFiles.put(countFiles++, imagesPath.concat(imageFullPath));
		    	String p = file.getPath();
				imgFiles.put(countFiles++, p);
		    }
		}	
	}
	
	public void moveFirst(){
		if(!imgFiles.isEmpty()){
			curImgIndex=0;                               
			filename=imgFiles.get(curImgIndex);
			repaint();
		}
	}

	public void moveNext(){
		if(!imgFiles.isEmpty() && curImgIndex<imgFiles.size()-1){
			curImgIndex++;                               
			filename=imgFiles.get(curImgIndex);
			repaint();
		}
	}

	public void movePrev(){
		if(!imgFiles.isEmpty() && curImgIndex>0){
			curImgIndex--;                               
			filename=imgFiles.get(curImgIndex);
			repaint();
		}
	}

	public HashMap<Integer,String> getImgFiles(){
		return imgFiles;
	}

}

//class ShowBrowser extends JFrame {
//
//	private static final long serialVersionUID = 1L;
//	JPanel panel;
//	ImageShow show;
//	boolean stop=true;
//	static GraphicsDevice device = GraphicsEnvironment
//	        .getLocalGraphicsEnvironment().getScreenDevices()[0];
//	
//	ShowBrowser(){
//		
//		//setTitle("Image Slide Show");
//		//setDefaultCloseOperation(EXIT_ON_CLOSE);
//		//setExtendedState(JFrame.MAXIMIZED_BOTH); 
//		//setUndecorated(true); 
//        //device.setFullScreenWindow(this);
//		//setBackground(Color.BLACK);
//		
//        JEditorPane website;
//		try {
//			website = new JEditorPane("http://www.leroynet.com/");
//		    website.setEditable(false);
//		    add(new JScrollPane(website));
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
//        setSize(800, 600);
//
//		setVisible(true);
//
//	}	
//}
//class  ShowBrowser extends JFrame  implements WebBrowserListener {
//
//	/**
//	 * 
//	 */
//	private static final long serialVersionUID = 1L;
//	JPanel panel;
//	ImageShow show;
//	boolean stop=true;
//	static GraphicsDevice device = GraphicsEnvironment
//	        .getLocalGraphicsEnvironment().getScreenDevices()[0];
//	
//	ShowBrowser(){
//	
//		setTitle("Image Slide Show");
//		setDefaultCloseOperation(EXIT_ON_CLOSE);
//		//setExtendedState(JFrame.MAXIMIZED_BOTH); 
//		//setUndecorated(true); 
//        //device.setFullScreenWindow(this);
//		setBackground(Color.BLACK);
//		
//		WebBrowser browser = BrowserFactory.instance().createBrowser();
//		browser.setListener(this); //See the WebBrowser interface for the available events.
//		browser.go("https://www.google.com");
//
//		add(browser.getComponent(), BorderLayout.CENTER);
//
//		setVisible(true);
//
//	}
//
//    @Override
//    public void onComplete(WebBrowser browser, String url) {
//        browser.function(new BrowserFunction("testFn") {
//            @Override
//            public String run(String data) {
//                return "Callback: " + data;
//            }
//        });
//    }
//    
//}

class  ShowInterface extends JFrame implements ActionListener{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	JButton btSlideShow;
	JButton btSlideNext;
	JButton btSlidePrev;
	JPanel panel;
	ImageShow show;
	boolean stop=true;
	ImageSlider slider;
	static GraphicsDevice device = GraphicsEnvironment
	        .getLocalGraphicsEnvironment().getScreenDevices()[0];
	

	ShowInterface(){
		
		setTitle("Image Slide Show");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setExtendedState(JFrame.MAXIMIZED_BOTH); 
		setUndecorated(true); 
        device.setFullScreenWindow(this);
		setVisible(true);
		setBackground(Color.BLACK);

		// Create the Play Button
		btSlideShow=new JButton(new ImageIcon("./images/play.png"));
		//btSlideShow.setBackground(Color.BLACK);
		btSlideShow.addActionListener(this);
		btSlideShow.setEnabled(false);

		// Create the Next Button
		btSlideNext =new JButton(new ImageIcon("./images/next.png"));
		//btSlideNext.setBackground(Color.BLACK);
		btSlideNext.addActionListener(this);
		btSlideNext.setEnabled(false);

		// Create the Previous Button
		btSlidePrev=new JButton(new ImageIcon("./images/previous.png"));
		//btSlidePrev.setBackground(Color.BLACK);
		btSlidePrev.addActionListener(this);
		btSlidePrev.setEnabled(false);

		panel=new JPanel();
		panel.setLayout(new FlowLayout());
		panel.add(btSlidePrev);
		panel.add(btSlideShow);
		panel.add(btSlideNext);
		panel.setBackground(Color.BLACK);
		add(panel, BorderLayout.SOUTH);

		show=new ImageShow();
		add(show,BorderLayout.CENTER );
		setVisible(true);

		show.storeImages();
		if(show.getImgFiles().size()>0){
			show.moveFirst();                                                   
			btSlideShow.setEnabled(true);
			btSlideNext.setEnabled(true);
			btSlidePrev.setEnabled(true);
		}

	}

	void close() {
		if(!stop){
			stopClick();
		} 
		setVisible(false);
		dispose();
	}

	public void showWeather() {
		this.setVisible(false);
		if(Desktop.isDesktopSupported()) {
			try {
				Desktop.getDesktop().browse(new URI("http://www.weather.com/weather/5day/l/USOH0188:1:US"));
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (URISyntaxException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
	public void showCalendar() {
		this.setVisible(false);
		if(Desktop.isDesktopSupported()) {
			try {
				Desktop.getDesktop().browse(new URI("https://calendar.google.com/calendar/render?pli=1#main_7%7Cmonth"));
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (URISyntaxException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	public void showPhotos() {
		this.setVisible(true);
	}
		
	public void actionPerformed(ActionEvent e){
		if(e.getSource()==btSlideShow)
		{
			if(stop){
				startClick();
			}
			else{
				stopClick();
			}
		}
		else {
			if(e.getSource()==btSlideNext)
			{
				show.moveNext();
			}
			else {
				if(e.getSource()==btSlidePrev)
				{
					show.movePrev();
				}
				else {
					JMenuItem source = (JMenuItem)(e.getSource());
					if(source.getText().compareTo("Open...")==0)
					{
						show.storeImages();
						if(show.getImgFiles().size()>0){
							show.moveFirst();                                                   
							btSlideShow.setEnabled(true);
						}
					}
					else if(source.getText().compareTo("Exit")==0)
						System.exit(0);
				}
			}
		}
	}

	public void startClick(){
		
		btSlideShow.setIcon(new ImageIcon("./images/pause.png"));
		stop=false;
		slider=new ImageSlider();
		slider.start();
		
	}          
	
	public void stopClick(){
		btSlideShow.setIcon(new ImageIcon("./images/play.png"));
		stop=true;                 
		slider.stopShow();
	}


	class ImageSlider extends Thread{
		boolean started;
		HashMap<Integer,String> map;
		ImageSlider(){
			started=true;
			map=show.getImgFiles();
		}

		public void run(){
			int i;
			try{
				while(started) {
					for(i=0;i<map.size();i++)
					{
						if(started!=false){
							Thread.sleep(10000);                                                           
							show.moveNext();
						}          
					}
//					show.moveFirst();
				}
			}catch(InterruptedException ie){System.out.println("Interrupted slide show...");}
		}

		public void stopShow(){
			started=false;
		}
		
	}

}



