
import com.pi4j.io.gpio.GpioController;
import com.pi4j.io.gpio.GpioFactory;
import com.pi4j.io.gpio.GpioPinDigitalInput;
import com.pi4j.io.gpio.PinPullResistance;
import com.pi4j.io.gpio.PinState;
import com.pi4j.io.gpio.RaspiPin;
import com.pi4j.io.gpio.event.GpioPinDigitalStateChangeEvent;
import com.pi4j.io.gpio.event.GpioPinListenerDigital;
 
 
public class ImageSlideShow {

	private static ShowWeather showWeather;
	private static ShowCalendar showCalendar;
	private static ShowInterface showInterface;		
	
    public static void main(String args[]) throws InterruptedException {
    	
    	System.out.println("GPI Listener starting ");
    	
	    // create gpio controller
	    final GpioController gpio = GpioFactory.getInstance();
 
        final GpioPinDigitalInput myButton1 = gpio.provisionDigitalInputPin(RaspiPin.GPIO_02, PinPullResistance.PULL_DOWN);

        // create and register gpio pin listener
        myButton1.addListener(new GpioPinListenerDigital() {
            @Override
            public void handleGpioPinDigitalStateChangeEvent(GpioPinDigitalStateChangeEvent event) {
                // display pin state on console
            	System.out.println(" --> GPIO PIN STATE CHANGE: " + event.getPin() + " = " + event.getState());
            	if (event.getState() == PinState.HIGH) {
	            	if (showCalendar != null) {
	            		showCalendar.close();
	            		showCalendar = null; 
	            	}
	            	if (showInterface != null) {
	                	showInterface.close();
	                	showInterface = null;            		
	            	}
	            	if (showWeather == null)
	            		showWeather = new ShowWeather();
            	}
            }
        });

        final GpioPinDigitalInput myButton2 = gpio.provisionDigitalInputPin(RaspiPin.GPIO_05, PinPullResistance.PULL_DOWN);

        // create and register gpio pin listener
        myButton2.addListener(new GpioPinListenerDigital() {
            @Override
            public void handleGpioPinDigitalStateChangeEvent(GpioPinDigitalStateChangeEvent event) {
                // display pin state on console
            	System.out.println(" --> GPIO PIN STATE CHANGE: " + event.getPin() + " = " + event.getState());
            	if (event.getState() == PinState.HIGH) {
	            	if (showWeather != null) {
	            		showWeather.close();
	            		showWeather = null;
	            	}
	            	if (showInterface != null) {
	                	showInterface.close();
	                	showInterface = null;            		
	            	}
	             	if (showCalendar == null)
	            		showCalendar = new ShowCalendar();
            	}
            }
        });

        final GpioPinDigitalInput myButton3 = gpio.provisionDigitalInputPin(RaspiPin.GPIO_06, PinPullResistance.PULL_DOWN);

        // create and register gpio pin listener
        myButton3.addListener(new GpioPinListenerDigital() {
            @Override
            public void handleGpioPinDigitalStateChangeEvent(GpioPinDigitalStateChangeEvent event) {
                // display pin state on console
            	System.out.println(" --> GPIO PIN STATE CHANGE: " + event.getPin() + " = " + event.getState());
            	if (event.getState() == PinState.HIGH) {
	            	if (showWeather != null) {
	            		showWeather.close();
	            		showWeather = null;
	            	}
	            	if (showCalendar != null) {
	            		showCalendar.close();
	            		showCalendar = null;            		
	            	}
	             	if (showInterface == null)
	            		showInterface = new ShowInterface();
            	}
            }
        });
      
        System.out.println("Completed Setup and now listening.");
        
        for (;;) {
        	Thread.sleep(500);
        }
/*
        	Thread.sleep(1000);
        	showWeather = null;
        	showCalendar = null;
        	if (showInterface == null)
        		showInterface = new ShowInterface();
        	Thread.sleep(1000);
        	showWeather = null;
        	showInterface = null;
        	if (showCalendar == null)
        		showCalendar = new ShowCalendar();
        	Thread.sleep(1000);
        	showCalendar = null;
        	showInterface = null;
        	if (showWeather == null)
        		showWeather = new ShowWeather();
*/        	
	}

}
